=== debian/changelog ===
bart (0.6.00-3) unstable; urgency=medium

  * Team upload
  * Remove redundant d/gbp.conf
  * Run tests on i386, mips64el and s390x but make the test succeed in any case

 -- Andreas Tille <tille@debian.org>  Mon, 21 Sep 2020 16:16:16 +0200

bart (0.6.00-2) unstable; urgency=medium

  * Team upload.
  * Mark tests superficial
    Closes: #969804
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 10 Sep 2020 08:59:31 +0200

bart (0.6.00-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.
  * Add upstream metadata.
  * Rules do not require root.
  * Standards-Version: 4.5.0

  [ Andreas Tille ]
  * Add salsa-ci

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Sat, 11 Jul 2020 15:42:45 +0200
