=== debian/tests/control ===
Test-Command: /usr/bin/bart version
Depends: bart
Restrictions: superficial

Tests: octave-integration
Depends: octave-bart, octave
Restrictions: superficial
