## bart 0.7.00

=== Makefile ===
--- 
+++ 
@@ -18,6 +18,7 @@
 # use for parallel make
 AR=./ar_lock.sh
 
+# use for ppc64le HPC
 MKL?=0
 CUDA?=0
 ACML?=0
@@ -25,8 +26,11 @@
 SLINK?=0
 DEBUG?=0
 FFTWTHREADS?=1
+SCALAPACK?=0
 ISMRMRD?=0
 NOEXEC_STACK?=0
+PARALLEL?=0
+PARALLEL_NJOBS?=
 
 LOG_BACKEND?=0
 LOG_SIEMENS_BACKEND?=0
@@ -45,6 +49,7 @@
 
 MYLINK=ln
 
+
 ifeq ($(UNAME),Darwin)
 	BUILDTYPE = MacOSX
 	MYLINK = ln -s
@@ -134,7 +139,7 @@
 
 # cuda
 
-CUDA_BASE ?= /usr/local/
+CUDA_BASE ?= /usr/
 
 
 # acml
@@ -142,7 +147,7 @@
 ACML_BASE ?= /usr/local/acml/acml4.4.0/gfortran64_mp/
 
 # mkl
-MKL_BASE ?= /opt/intel/mkl/lib/intel64/ 
+MKL_BASE ?= /opt/intel/mkl/lib/intel64/
 
 # fftw
 
@@ -167,11 +172,11 @@
 #
 TBASE=show slice crop resize join transpose squeeze flatten zeros ones flip circshift extract repmat bitmask reshape version delta copy casorati vec poly index
 TFLP=scale invert conj fmac saxpy sdot spow cpyphs creal carg normalize cdf97 pattern nrmse mip avg cabs zexp
-TNUM=fft fftmod fftshift noise bench threshold conv rss filter mandelbrot wavelet window var std fftrot
-TRECO=pics pocsense sqpics itsense nlinv moba nufft rof tgv sake wave lrmatrix estdims estshift estdelay wavepsf wshfl rtnlinv
+TNUM=fft fftmod fftshift noise bench threshold conv rss filter mandelbrot wavelet window var std fftrot roistat pol2mask conway
+TRECO=pics pocsense sqpics itsense nlinv moba nufft rof tgv sake wave lrmatrix estdims estshift estdelay wavepsf wshfl rtnlinv mobafit
 TCALIB=ecalib ecaltwo caldir walsh cc ccapply calmat svd estvar whiten rmfreq ssa bin
 TMRI=homodyne poisson twixread fakeksp looklocker upat
-TSIM=phantom traj
+TSIM=phantom traj signal
 TIO=toimg
 
 
@@ -183,7 +188,8 @@
 MODULES_pocsense = -lsense -liter -llinops -lwavelet
 MODULES_nlinv = -lnoir -liter -lnlops -llinops -lnoncart
 MODULES_rtnlinv = -lnoir -liter -lnlops -llinops -lnoncart
-MODULES_moba = -lmoba -lnoir -liter -lnlops -llinops -lwavelet -lnoncart
+MODULES_moba = -lmoba -lnoir -lnlops -llinops -lwavelet -lnoncart -lsimu -lgrecon -llowrank -llinops -liter
+MODULES_mobafit = -lmoba -lnlops -llinops -lsimu -liter
 MODULES_bpsense = -lsense -lnoncart -liter -llinops -lwavelet
 MODULES_itsense = -liter -llinops
 MODULES_ecalib = -lcalib
@@ -213,6 +219,8 @@
 MODULES_wshfl = -lgrecon -lsense -liter -llinops -lwavelet -llowrank -lnoncart
 MODULES_ssa = -lcalib
 MODULES_bin = -lcalib
+MODULES_signal = -lsimu
+MODULES_pol2mask = -lgeom
 
 
 MAKEFILES = $(wildcard $(root)/Makefiles/Makefile.*)
@@ -262,18 +270,19 @@
 CPPFLAGS += -DNOEXEC_STACK
 endif
 
+
 ifeq ($(PARALLEL),1)
-MAKEFLAGS += -j
+MAKEFLAGS += -j$(PARALLEL_NJOBS)
 endif
 
 
 ifeq ($(MAKESTAGE),1)
 .PHONY: doc/commands.txt $(TARGETS)
 default all clean allclean distclean doc/commands.txt doxygen test utest utest_gpu gputest pythontest $(TARGETS):
-	make MAKESTAGE=2 $(MAKECMDGOALS)
+	$(MAKE) MAKESTAGE=2 $(MAKECMDGOALS)
 
 tests/test-%: force
-	make MAKESTAGE=2 $(MAKECMDGOALS)
+	$(MAKE) MAKESTAGE=2 $(MAKECMDGOALS)
 
 force: ;
 
@@ -306,15 +315,15 @@
 ifeq ($(BUILDTYPE), MacOSX)
 CUDA_L := -L$(CUDA_BASE)/lib -lcufft -lcudart -lcublas -m64 -lstdc++
 else
-CUDA_L := -L$(CUDA_BASE)/lib64 -lcufft -lcudart -lcublas -lstdc++ -Wl,-rpath $(CUDA_BASE)/lib64
-endif 
+CUDA_L := -L$(CUDA_BASE)/lib -lcufft -lcudart -lcublas -lstdc++ -Wl,-rpath $(CUDA_BASE)/lib
+endif
 else
 CUDA_H :=
-CUDA_L :=  
+CUDA_L :=
 endif
 
 # sm_20 no longer supported in CUDA 9
-GPUARCH_FLAGS ?= 
+GPUARCH_FLAGS ?=
 NVCCFLAGS = -DUSE_CUDA -Xcompiler -fPIC -Xcompiler -fopenmp -O3 $(GPUARCH_FLAGS) -I$(srcdir)/ -m64 -ccbin $(CC)
 #NVCCFLAGS = -Xcompiler -fPIC -Xcompiler -fopenmp -O3  -I$(srcdir)/
 
@@ -337,7 +346,9 @@
 
 
 # BLAS/LAPACK
-
+ifeq ($(SCALAPACK),1)
+BLAS_L :=  -lopenblas -lscalapack
+else
 ifeq ($(ACML),1)
 BLAS_H := -I$(ACML_BASE)/include
 BLAS_L := -L$(ACML_BASE)/lib -lgfortran -lacml_mp -Wl,-rpath $(ACML_BASE)/lib
@@ -352,6 +363,7 @@
 CPPFLAGS += -Isrc/lapacke
 else
 BLAS_L := -L$(BLAS_BASE)/lib -llapacke -lblas
+endif
 endif
 endif
 endif
@@ -439,10 +451,14 @@
 # change for static linking
 
 ifeq ($(SLINK),1)
+ifeq ($(SCALAPACK),1)
+BLAS_L += -lgfortran -lquadmath
+else
 # work around fortran problems with static linking
 LDFLAGS += -static -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -Wl,--allow-multiple-definition
 LIBS += -lmvec
 BLAS_L += -llapack -lblas -lgfortran -lquadmath
+endif
 endif
 
 
@@ -473,6 +489,9 @@
 endef
 
 ALIBS = misc num grecon sense noir iter linops wavelet lowrank noncart calib simu sake dfwavelet nlops moba lapacke box geom
+ifeq ($(ISMRMRD),1)
+ALIBS += ismrm
+endif
 $(eval $(foreach t,$(ALIBS),$(eval $(call alib,$(t)))))
 
 
@@ -500,7 +519,7 @@
 
 # lib moba
 UTARGETS += test_moba
-MODULES_test_moba += -lmoba -lnlops -llinops
+MODULES_test_moba += -lmoba -lnoir -llowrank -lwavelet -liter -lnlops -llinops -lsimu
 
 # lib nlop
 UTARGETS += test_nlop
@@ -511,14 +530,19 @@
 MODULES_test_nufft += -lnoncart -llinops
 
 # lib num
-UTARGETS += test_multind test_flpmath test_splines test_linalg test_polynom test_window
-UTARGETS += test_blas test_mdfft test_ops test_ops_p
+UTARGETS += test_multind test_flpmath test_splines test_linalg test_polynom test_window test_conv
+UTARGETS += test_blas test_mdfft test_ops test_ops_p test_flpmath2
 UTARGETS_GPU += test_cudafft
 
 # lib simu
-UTARGETS += test_ode_bloch test_biot_savart
+UTARGETS += test_ode_bloch test_biot_savart test_signals
 MODULES_test_ode_bloch += -lsimu
 MODULES_test_biot_savart += -lsimu
+MODULES_test_signals += -lsimu
+
+# lib geom
+UTARGETS += test_geom
+MODULES_test_geom += -lgeom
 
 # lib iter
 UTARGETS += test_iter test_prox
@@ -559,37 +583,3 @@
 # special targets
 
 
-$(XTARGETS): CPPFLAGS += -DMAIN_LIST="$(XTARGETS:%=%,) ()" -include src/main.h
-
-
-bart: CPPFLAGS += -DMAIN_LIST="$(XTARGETS:%=%,) ()" -include src/main.h
-
-
-mat2cfl: $(srcdir)/mat2cfl.c -lnum -lmisc
-	$(CC) $(CFLAGS) $(MATLAB_H) -omat2cfl  $+ $(MATLAB_L) $(CUDA_L)
-
-
-
-
-
-# implicit rules
-
-%.o: %.c
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c -o $@ $<
-
-%.o: %.cc
-	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -c -o $@ $<
-
-ifeq ($(PARALLEL),1)
-(%): %
-	$(AR) $(ARFLAGS) $@ $%
-else
-(%): %
-	$(AR) $(ARFLAGS) $@ $%
-endif
-
-
-
-
-.SECONDEXPANSION:
-$(TARGETS): % : src/main.c $(srcdir)/%.o $$(MODULES_%) $(MODULES)
