=== debian/changelog ===
bart (0.7.00-2) unstable; urgency=medium

  * Fix cross-builds by reverting patch for deterministic archives.
  * Arm the unit tests on mips64el.
  * Add workaround for compiler bug on armel and s390x.
  * Drop old compatibility patch.

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Thu, 30 Dec 2021 16:28:18 +0100

bart (0.7.00-1) unstable; urgency=medium

  [ Martin Uecker ]
  * New upstream version.
  * Patch to change library path for cuda.
  * Update upstream metadata.
  * Patch to relax failing unit test.
  * Patch to work around compiler bug.
  * Deterministic build.
  * Run test suite.
  * Don't update commands.txt.
  * Backport fixes for tests.

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)
  * No tab in license text (routine-update)

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Thu, 26 Aug 2021 15:05:30 +0200
