=== debian/tests/control ===
--- 
+++ 
@@ -5,3 +5,17 @@
 Tests: octave-integration
 Depends: octave-bart, octave
 Restrictions: superficial
+
+Tests: commands
+Depends: bart
+Restrictions: superficial
+
+Tests: suite
+Depends: bart, make
+Architecture: amd64
+Restrictions: allow-stderr
+
+Tests: suite
+Depends: bart, make
+Architecture: i386, mips64el, s390x
+Restrictions: allow-stderr, flaky
