## bart 0.8.00

=== debian/changelog ===
bart (0.8.00-3) unstable; urgency=medium

  * Run more unit tests.
  * Turn off two hanging tests on i386.
  * Add geometry library now required by bart-view.

 -- Martin Uecker <uecker@tugraz.at>  Tue, 25 Oct 2022 01:12:46 +0530

bart (0.8.00-2) unstable; urgency=medium

  * Backport fixes for upstream (should also fix 32-bit archs)
  * Turn on tests for more archs.
  * Turn off some optimizations for some archs.
  * Update debian copyright.
  * Relax some flaky tests.

 -- Martin Uecker <uecker@tugraz.at>  Thu, 13 Oct 2022 19:30:06 +0200

bart (0.8.00-1) unstable; urgency=medium

  * Turn off LTO build due to GCC bug #1017849. (Closes: #1015357)
  * Add std=c++14 to nvcc to fix build issues.
  * New upstream version.
  * Standards-Version: 4.6.1.0
  * Extend devel-package.
  * Mention machine learning in description.

 -- Martin Uecker <uecker@tugraz.at>  Sun, 25 Sep 2022 13:48:43 +0200

bart (0.7.00-3) unstable; urgency=medium

  * Turn off parallel build for determinism.
  * Arm the unit tests on s390x.
  * On Debian never use git version.
  * Workaround for octave bug in integration test. (Closes: #1010164)

 -- Martin Uecker <martin.uecker@med.uni-goettingen.de>  Fri, 31 Dec 2021 10:31:15 +0100
