=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: bart
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Martin Uecker <martin.uecker@med.uni-goettingen.de>
+Uploaders: Martin Uecker <uecker@tugraz.at>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -8,7 +8,7 @@
                liblapack-dev | liblapack.so,
                libpng-dev,
                liblapacke-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1.0
 Vcs-Browser: https://salsa.debian.org/med-team/bart
 Vcs-Git: https://salsa.debian.org/med-team/bart.git
 Homepage: https://mrirecon.github.io/bart/
@@ -28,8 +28,8 @@
  generic implementations of iterative optimization algorithms. The
  command-line tools provide direct access to basic operations on
  multi-dimensional arrays as well as efficient implementations of
- many calibration and reconstruction algorithms for parallel imaging
- and compressed sensing.
+ many calibration and reconstruction algorithms for parallel imaging,
+ compressed sensing, and machine learning.
 
 Package: libbart-dev
 Architecture: any
